var e=require("xstate"),t=require("ploson"),r=require("ramda"),o=require("joi"),n=require("date-fns/fp/index.js"),i=require("lodash.iserror"),a=require("rfc6902");function s(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function d(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach(function(r){if("default"!==r){var o=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,o.get?o:{enumerable:!0,get:function(){return e[r]}})}}),t.default=e,t}var c=/*#__PURE__*/d(r),l=/*#__PURE__*/s(o),u=/*#__PURE__*/s(i);const p=l.default.object().unknown().keys({id:l.default.string().required().description("Identifier for this particular rule."),active:l.default.boolean().description("If the rule is active or not. An inactive rule is not run at all."),ttl:l.default.date().default(0xfd4fff4e446).description("At this time (ISO timestamp) the rule will be set to inactive."),onLoad:l.default.any().description("Ploson code to e.g. create reusable constants and functions."),cooldown:l.default.number().min(0).description("A rule can't be triggered again unless this number of seconds has passed."),resetCondition:l.default.any().description("Ploson code to check if rule should reset, if it is in flipped state."),resetAction:l.default.any().description("Ploson code block to execute when resetCondition is true."),condition:l.default.any().default(!0).description("Ploson code to check if rule should execute (state to flipped, run actions etc)."),action:l.default.any().description("Ploson code block to execute when condition is true (& not in flipped state).")}),g=function({ploson:e,code:t,createReturn:r=c.identity}){try{return Promise.resolve(e(t)).then(function(e){return u.default(e)?Promise.reject(e):r(e)})}catch(e){return Promise.reject(e)}},f={delays:{COOLDOWN:({cooldown:e})=>e},guards:{hasCooldown:({cooldown:e})=>Boolean(e),hasHysteresis:({hysteresis:e})=>e,conditionTruthy:(e,{data:[r]=t.ARR})=>Boolean(r),isExpired:({ttl:e})=>n.isBefore(new Date)(e)},services:{checkIfExpired:({ttl:e},{payload:t})=>n.isBefore(new Date)(e)?Promise.reject(Error("Take onError path")):Promise.resolve({payload:t}),condition:({condition:e,ploson:t},{data:{payload:r}})=>g({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),resetCondition:({resetCondition:e,ploson:t},{payload:r})=>g({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),action:function({action:e,ploson:r},{data:[,o]=t.ARR}){try{return g({ploson:r,payload:o,code:[",",{payload:Promise.resolve(o)},e]})}catch(e){return Promise.reject(e)}},resetAction:({resetAction:e,ploson:r},{data:[,o]=t.ARR})=>g({ploson:r,payload:o,code:[",",{payload:Promise.resolve(o)},e]})},actions:{logError:(e,{data:t})=>console.error(t),updateRule:()=>e.assign({ttl:(e,{rule:{ttl:r}=t.OBJ})=>r,hysteresis:(e,{rule:{hysteresis:r}=t.OBJ})=>r,condition:(e,{rule:{condition:r}=t.OBJ})=>r,action:(e,{rule:{action:r}=t.OBJ})=>r,cooldown:(e,{rule:{cooldown:r}=t.OBJ})=>r,resetCondition:(e,{rule:{resetCondition:r}=t.OBJ})=>r,resetAction:(e,{rule:{resetAction:r}=t.OBJ})=>r})}},R=e.createMachine({predictableActionArguments:!0,initial:"idle",on:{INACTIVATE:"inactive",UPDATE:{actions:"updateRule"}},states:{inactive:{on:{ACTIVATE:"idle"}},idle:{on:{FIRE:"checkExpired"}},checkExpired:{invoke:{src:"checkIfExpired",onDone:"checkCondition",onError:"expired"}},checkCondition:{invoke:{src:"condition",onDone:[{cond:"conditionTruthy",target:"executeAction"},{target:"idle"}],onError:{actions:"logError",target:"idle"}}},executeAction:{invoke:{src:"action",onDone:{target:"fired"},onError:{actions:"logError",target:"fired"}}},fired:{type:"parallel",states:{switcher:{initial:"decide",states:{decide:{always:[{cond:"hasHysteresis",target:"flipped"},{target:"done"}]},flipped:{on:{FIRE:"checkCondition"}},checkCondition:{invoke:{src:"resetCondition",onDone:[{cond:"conditionTruthy",target:"executeResetAction"},{target:"flipped"}],onError:{actions:"logError",target:"executeResetAction"}}},executeResetAction:{invoke:{src:"resetAction",onDone:{target:"done"},onError:{actions:"logError",target:"done"}}},done:{type:"final"}}},temperature:{initial:"decide",states:{decide:{always:[{cond:"hasCooldown",target:"hot"},{target:"cool"}]},hot:{after:{COOLDOWN:"cool"}},cool:{type:"final"}}}},onDone:"idle"},expired:{type:"final"}}},f),E=c.differenceWith(({id:e}=t.OBJ,{id:r}=t.OBJ)=>e===r),y=({idKey:e="id",ignoreKeys:t,skipIf:r,transformAdded:o,transformUpdated:n}={})=>i=>c.converge(c.mergeLeft,[c.reduce((s,d)=>{if(r&&r(d))return s;const{[e]:l}=d,u=c.find(c.propEq("id",l))(i);if(u){const e=c.when(()=>t,c.map(c.omit(t)))([u,d]),r=a.createPatch(...e);return c.isEmpty(r)?s:{...s,updated:[...s.updated,n?n(d,u,r):d]}}return{...s,added:[...s.added,o?o(d):d]}},{added:[],updated:[]}),c.pipe(E(i),c.objOf("removed"))]),{pure:v,stop:h}=e.actions,m=c.groupBy(({callback:e})=>e?"updatedSoft":"updatedHard"),A=c.map(({trigger:e,ploson:t,...r})=>g({ploson:t,code:e,createReturn:o=>({...r,trigger:e,ploson:t,callback:o})})),k=(e,t)=>r=>e((e,o)=>r({type:"FIRE_RULES",targets:o??t,payload:e})),T=c.map(({id:r,targets:o,callback:n,...i})=>({id:r,targets:o,callback:n,...i,...n?{ref:e.spawn(k(n,o),r)}:t.OBJ})),O={predictableActionArguments:!0,id:"rule-manager",initial:"initRules",context:{rules:[],triggers:[]},states:{retryRules:{after:{RETRY_DELAY:{target:"initRules"}}},initRules:{invoke:{src:"ruleFetcher",onDone:"prepareRules",onError:{actions:"logError",target:"retryRules"}}},prepareRules:{invoke:{id:"processInitRules",src:"processRules",onDone:{actions:"addRules",target:"initTriggers"},onError:{actions:"logError",target:"initTriggers"}}},retryTriggers:{after:{RETRY_DELAY:{target:"initTriggers"}}},initTriggers:{invoke:{src:"triggerFetcher",onDone:{target:"prepareTriggers"},onError:{actions:"logError",target:"retryTriggers"}}},prepareTriggers:{invoke:{id:"processInitTriggers",src:"processTriggers",onDone:{actions:["addTriggers","spawnUpdater"],target:"running"},onError:{actions:"logError",target:"running"}}},running:{initial:"idle",on:{FIRE_RULES:{actions:"fireRules"}},states:{idle:{on:{UPDATE_RULES:{target:"updatingRules"},UPDATE_TRIGGERS:{target:"updatingTriggers"}}},updatingRules:{invoke:{id:"processRuleUpdates",src:"processRules",onDone:{target:"idle",actions:["killActors","removeRules","addRules","updateRules"]},onError:{target:"idle",actions:"logError"}}},updatingTriggers:{invoke:{id:"processTriggerUpdates",src:"processTriggers",onDone:{target:"idle",actions:["killActors","removeTriggers","addTriggers"]},onError:{target:"idle",actions:"logError"}}}}}}},w=r=>e.createMachine(O,(({ruleFetcher:r=(()=>Promise.resolve(t.ARR)),triggerFetcher:o=(()=>Promise.resolve(t.ARR)),staticEnv:n=t.OBJ,staticEnvTriggers:i=n,updater:a=t.FUNC})=>{const s=y({ignoreKeys:["ref","ploson","active"],skipIf:({active:e})=>!e,transformAdded:e=>{const{value:r,error:o,warning:i}=p.validate(e);return(o||i)&&console.warn(o||i),{...r,ploson:t.createRunner({staticEnv:n})}},transformUpdated:(e,{ploson:t,ref:r})=>({...e,ploson:t,ref:r})}),d=y({ignoreKeys:["ploson","callback","ref","active"],skipIf:({active:e})=>!e,transformAdded:({targets:e=t.ARR,...r})=>({...r,targets:e,ploson:t.createRunner({staticEnv:i})}),transformUpdated:(e,{ploson:r,callback:o,ref:n},i)=>({...e,ploson:r,ref:n,...c.any(c.propEq("path","/trigger"))(i)?t.OBJ:{callback:o}})});return{delays:{RETRY_DELAY:3e4},services:{ruleFetcher:r,triggerFetcher:o,processRules:function({rules:e},{data:r=t.ARR}){try{const{added:t,updated:o,removed:n}=s(e)(r);return Promise.resolve(Promise.all(c.map(({onLoad:e,ploson:t})=>e?g({ploson:t,code:e}):Promise.resolve())([...t,...o]))).then(function(){return{added:t,toRemove:n,toUpdate:o}})}catch(e){return Promise.reject(e)}},processTriggers:function({triggers:e},{data:r=t.ARR}){try{const{added:o,updated:n,removed:i}=d(e)(r),{updatedHard:a=t.ARR,updatedSoft:s=t.ARR}=m(n);return Promise.resolve(Promise.all(A([...o,...a]))).then(function(e){return{added:e,toRemove:[...i,...a],toUpdate:s}})}catch(e){return Promise.reject(e)}}},actions:{logError:(e,{data:t})=>console.error(t),killActors:v((e,{data:{toRemove:r=t.ARR,toRestart:o=t.ARR}=t.OBJ})=>c.into([],c.pipe(c.filter(({ref:e})=>Boolean(e)),c.map(({ref:e})=>h(e))))([...r,...o])),removeTriggers:e.assign({triggers:({triggers:e},{data:{toRemove:r=t.ARR}=t.OBJ})=>E(e,r)}),addTriggers:e.assign({triggers:({triggers:e},{data:{added:r=t.ARR}=t.OBJ})=>(console.info("Spawning triggers:",c.pluck("id",r)),[...e,...T(r)])}),updateTriggers:e.assign({triggers:({triggers:e},{data:{toUpdate:r=t.ARR}=t.OBJ})=>c.map(e=>{const t=c.find(c.propEq("id",e.id))(r);return t?c.assoc("targets",t.targets??[],e):e})(e)}),removeRules:e.assign({rules:({rules:e},{data:{toRemove:r=t.ARR}=t.OBJ})=>E(e,r)}),addRules:e.assign({rules:({rules:r},{data:{added:o=t.ARR}=t.OBJ})=>[...r,...c.map(({id:r,active:o,ttl:n,resetCondition:i,resetAction:a,cooldown:s,condition:d,action:c,ploson:l,...u})=>{const p=Boolean(i);return{id:r,active:o,ttl:n,ploson:l,...u,...o?{ref:e.spawn(R.withContext({ttl:n,hysteresis:p,condition:d,action:c,ploson:l,resetCondition:i,resetAction:a,cooldown:s}),r)}:t.OBJ}})(o)]}),updateRules:v((r,{data:{toUpdate:o=t.ARR}=t.OBJ})=>c.chain(({active:t,ttl:r,resetCondition:o,resetAction:n,cooldown:i,condition:a,action:s,ref:d})=>{const c=Boolean(o),l=e.send({type:"UPDATE",rule:{ttl:r,hysteresis:c,condition:a,action:s,resetCondition:o,resetAction:n,cooldown:i}},{to:d});return t?[l]:[e.send("INACTIVATE",{to:d}),l]})(o)),fireRules:v(({rules:t},{targets:r,payload:o})=>c.reduce((t,{id:n,active:i,ref:a})=>i&&a&&c.includes(n,r)?[...t,e.send({type:"FIRE",payload:o},{to:a})]:t,[])(t)),spawnUpdater:e.assign({updaterRef:()=>e.spawn(a,"rule-trigger-updater")})}}})(r));exports.Rule=p,exports.createRuleEngine=function(){return e.interpret(w(...[].slice.call(arguments)))},exports.createRuleEngineMachine=w;
//# sourceMappingURL=ploson-rule-engine.js.map
