import{createMachine as e,assign as t,spawn as r,interpret as o,send as i,actions as n}from"xstate";import{ARR as s,OBJ as a,FUNC as d,createRunner as c}from"ploson";import*as l from"ramda";import p from"joi";import{isBefore as g}from"date-fns/fp/index.js";import u from"lodash.iserror";import{createPatch as f}from"rfc6902";const m=p.object().unknown().keys({id:p.string().required().description("Identifier for this particular rule."),active:p.boolean().description("If the rule is active or not. An inactive rule is not run at all."),ttl:p.date().default(0xfd4fff4e446).description("At this time (ISO timestamp) the rule will be set to inactive."),onLoad:p.any().description("Ploson code to e.g. create reusable constants and functions."),cooldown:p.number().min(0).description("A rule can't be triggered again unless this number of seconds has passed."),resetCondition:p.any().description("Ploson code to check if rule should reset, if it is in flipped state."),resetAction:p.any().description("Ploson code block to execute when resetCondition is true."),condition:p.any().default(!0).description("Ploson code to check if rule should execute (state to flipped, run actions etc)."),action:p.any().description("Ploson code block to execute when condition is true (& not in flipped state).")}),E=function({ploson:e,code:t,createReturn:r=l.identity}){try{return Promise.resolve(e(t)).then(function(e){return u(e)?Promise.reject(e):r(e)})}catch(e){return Promise.reject(e)}},y=e({predictableActionArguments:!0,initial:"idle",on:{INACTIVATE:"inactive",UPDATE:{actions:"updateRule"}},states:{inactive:{on:{ACTIVATE:"idle"}},idle:{on:{FIRE:"checkExpired"}},checkExpired:{invoke:{src:"checkIfExpired",onDone:"checkCondition",onError:"expired"}},checkCondition:{invoke:{src:"condition",onDone:[{cond:"conditionTruthy",target:"executeAction"},{target:"idle"}],onError:{actions:"logError",target:"idle"}}},executeAction:{invoke:{src:"action",onDone:{target:"fired"},onError:{actions:"logError",target:"fired"}}},fired:{type:"parallel",states:{switcher:{initial:"decide",states:{decide:{always:[{cond:"hasHysteresis",target:"flipped"},{target:"done"}]},flipped:{on:{FIRE:"checkCondition"}},checkCondition:{invoke:{src:"resetCondition",onDone:[{cond:"conditionTruthy",target:"executeResetAction"},{target:"flipped"}],onError:{actions:"logError",target:"executeResetAction"}}},executeResetAction:{invoke:{src:"resetAction",onDone:{target:"done"},onError:{actions:"logError",target:"done"}}},done:{type:"final"}}},temperature:{initial:"decide",states:{decide:{always:[{cond:"hasCooldown",target:"hot"},{target:"cool"}]},hot:{after:{COOLDOWN:"cool"}},cool:{type:"final"}}}},onDone:"idle"},expired:{type:"final"}}},{delays:{COOLDOWN:({cooldown:e})=>e},guards:{hasCooldown:({cooldown:e})=>Boolean(e),hasHysteresis:({hysteresis:e})=>e,conditionTruthy:(e,{data:[t]=s})=>Boolean(t),isExpired:({ttl:e})=>g(new Date)(e)},services:{checkIfExpired:({ttl:e},{payload:t})=>g(new Date)(e)?Promise.reject(Error("Take onError path")):Promise.resolve({payload:t}),condition:({condition:e,ploson:t},{data:{payload:r}})=>E({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),resetCondition:({resetCondition:e,ploson:t},{payload:r})=>E({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),action:function({action:e,ploson:t},{data:[,r]=s}){try{return E({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e]})}catch(e){return Promise.reject(e)}},resetAction:({resetAction:e,ploson:t},{data:[,r]=s})=>E({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e]})},actions:{logError:(e,{data:t})=>console.error(t),updateRule:()=>t({ttl:(e,{rule:{ttl:t}=a})=>t,hysteresis:(e,{rule:{hysteresis:t}=a})=>t,condition:(e,{rule:{condition:t}=a})=>t,action:(e,{rule:{action:t}=a})=>t,cooldown:(e,{rule:{cooldown:t}=a})=>t,resetCondition:(e,{rule:{resetCondition:t}=a})=>t,resetAction:(e,{rule:{resetAction:t}=a})=>t})}}),v=l.differenceWith(({id:e}=a,{id:t}=a)=>e===t),h=({idKey:e="id",ignoreKeys:t,skipIf:r,transformAdded:o,transformUpdated:i}={})=>n=>l.converge(l.mergeLeft,[l.reduce((s,a)=>{if(r&&r(a))return s;const{[e]:d}=a,c=l.find(l.propEq("id",d))(n);if(c){const e=l.when(()=>t,l.map(l.omit(t)))([c,a]),r=f(...e);return l.isEmpty(r)?s:{...s,updated:[...s.updated,i?i(a,c,r):a]}}return{...s,added:[...s.added,o?o(a):a]}},{added:[],updated:[]}),l.pipe(v(n),l.objOf("removed"))]),{pure:R,stop:A}=n,k=l.groupBy(({callback:e})=>e?"updatedSoft":"updatedHard"),T=l.map(({trigger:e,ploson:t,...r})=>E({ploson:t,code:e,createReturn:o=>({...r,trigger:e,ploson:t,callback:o})})),P=(e,t)=>r=>e((e,o)=>r({type:"FIRE_RULES",targets:o??t,payload:e})),w=l.map(({id:e,targets:t,callback:o,...i})=>({id:e,targets:t,callback:o,...i,...o?{ref:r(P(o,t),e)}:a})),C={predictableActionArguments:!0,id:"rule-manager",initial:"initRules",context:{rules:[],triggers:[]},states:{retryRules:{after:{RETRY_DELAY:{target:"initRules"}}},initRules:{invoke:{src:"ruleFetcher",onDone:"prepareRules",onError:{actions:"logError",target:"retryRules"}}},prepareRules:{invoke:{id:"processInitRules",src:"processRules",onDone:{actions:"addRules",target:"initTriggers"},onError:{actions:"logError",target:"initTriggers"}}},retryTriggers:{after:{RETRY_DELAY:{target:"initTriggers"}}},initTriggers:{invoke:{src:"triggerFetcher",onDone:{target:"prepareTriggers"},onError:{actions:"logError",target:"retryTriggers"}}},prepareTriggers:{invoke:{id:"processInitTriggers",src:"processTriggers",onDone:{actions:["addTriggers","spawnUpdater"],target:"running"},onError:{actions:"logError",target:"running"}}},running:{initial:"idle",on:{FIRE_RULES:{actions:"fireRules"}},states:{idle:{on:{UPDATE_RULES:{target:"updatingRules"},UPDATE_TRIGGERS:{target:"updatingTriggers"}}},updatingRules:{invoke:{id:"processRuleUpdates",src:"processRules",onDone:{target:"idle",actions:["killActors","removeRules","addRules","updateRules"]},onError:{target:"idle",actions:"logError"}}},updatingTriggers:{invoke:{id:"processTriggerUpdates",src:"processTriggers",onDone:{target:"idle",actions:["killActors","removeTriggers","addTriggers"]},onError:{target:"idle",actions:"logError"}}}}}}},D=o=>e(C,(({ruleFetcher:e=(()=>Promise.resolve(s)),triggerFetcher:o=(()=>Promise.resolve(s)),staticEnv:n=a,staticEnvTriggers:p=n,updater:g=d})=>{const u=h({ignoreKeys:["ref","ploson","active"],skipIf:({active:e})=>!e,transformAdded:e=>{const{value:t,error:r,warning:o}=m.validate(e);return(r||o)&&console.warn(r||o),{...t,ploson:c({staticEnv:n})}},transformUpdated:(e,{ploson:t,ref:r})=>({...e,ploson:t,ref:r})}),f=h({ignoreKeys:["ploson","callback","ref","active"],skipIf:({active:e})=>!e,transformAdded:({targets:e=s,...t})=>({...t,targets:e,ploson:c({staticEnv:p})}),transformUpdated:(e,{ploson:t,callback:r,ref:o},i)=>({...e,ploson:t,ref:o,...l.any(l.propEq("path","/trigger"))(i)?a:{callback:r}})});return{delays:{RETRY_DELAY:3e4},services:{ruleFetcher:e,triggerFetcher:o,processRules:function({rules:e},{data:t=s}){try{const{added:r,updated:o,removed:i}=u(e)(t);return Promise.resolve(Promise.all(l.map(({onLoad:e,ploson:t})=>e?E({ploson:t,code:e}):Promise.resolve())([...r,...o]))).then(function(){return{added:r,toRemove:i,toUpdate:o}})}catch(e){return Promise.reject(e)}},processTriggers:function({triggers:e},{data:t=s}){try{const{added:r,updated:o,removed:i}=f(e)(t),{updatedHard:n=s,updatedSoft:a=s}=k(o);return Promise.resolve(Promise.all(T([...r,...n]))).then(function(e){return{added:e,toRemove:[...i,...n],toUpdate:a}})}catch(e){return Promise.reject(e)}}},actions:{logError:(e,{data:t})=>console.error(t),killActors:R((e,{data:{toRemove:t=s,toRestart:r=s}=a})=>l.into([],l.pipe(l.filter(({ref:e})=>Boolean(e)),l.map(({ref:e})=>A(e))))([...t,...r])),removeTriggers:t({triggers:({triggers:e},{data:{toRemove:t=s}=a})=>v(e,t)}),addTriggers:t({triggers:({triggers:e},{data:{added:t=s}=a})=>(console.info("Spawning triggers:",l.pluck("id",t)),[...e,...w(t)])}),updateTriggers:t({triggers:({triggers:e},{data:{toUpdate:t=s}=a})=>l.map(e=>{const r=l.find(l.propEq("id",e.id))(t);return r?l.assoc("targets",r.targets??[],e):e})(e)}),removeRules:t({rules:({rules:e},{data:{toRemove:t=s}=a})=>v(e,t)}),addRules:t({rules:({rules:e},{data:{added:t=s}=a})=>[...e,...l.map(({id:e,active:t,ttl:o,resetCondition:i,resetAction:n,cooldown:s,condition:d,action:c,ploson:l,...p})=>{const g=Boolean(i);return{id:e,active:t,ttl:o,ploson:l,...p,...t?{ref:r(y.withContext({ttl:o,hysteresis:g,condition:d,action:c,ploson:l,resetCondition:i,resetAction:n,cooldown:s}),e)}:a}})(t)]}),updateRules:R((e,{data:{toUpdate:t=s}=a})=>l.chain(({active:e,ttl:t,resetCondition:r,resetAction:o,cooldown:n,condition:s,action:a,ref:d})=>{const c=Boolean(r),l=i({type:"UPDATE",rule:{ttl:t,hysteresis:c,condition:s,action:a,resetCondition:r,resetAction:o,cooldown:n}},{to:d});return e?[l]:[i("INACTIVATE",{to:d}),l]})(t)),fireRules:R(({rules:e},{targets:t,payload:r})=>l.reduce((e,{id:o,active:n,ref:s})=>n&&s&&l.includes(o,t)?[...e,i({type:"FIRE",payload:r},{to:s})]:e,[])(e)),spawnUpdater:t({updaterRef:()=>r(g,"rule-trigger-updater")})}}})(o)),x=function(){return o(D(...[].slice.call(arguments)))};export{m as Rule,x as createRuleEngine,D as createRuleEngineMachine};
//# sourceMappingURL=ploson-rule-engine.module.mjs.map
