!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("xstate"),require("ploson"),require("ramda"),require("joi"),require("date-fns/fp/index.js"),require("lodash.iserror"),require("rfc6902")):"function"==typeof define&&define.amd?define(["exports","xstate","ploson","ramda","joi","date-fns/fp/index.js","lodash.iserror","rfc6902"],t):t((e||self).plosonRuleEngine={},e.xstate,e.ploson,e.ramda,e.joi,e.index_js,e.isError,e.rfc6902)}(this,function(e,t,r,o,n,i,s,a){function d(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function c(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach(function(r){if("default"!==r){var o=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,o.get?o:{enumerable:!0,get:function(){return e[r]}})}}),t.default=e,t}var l=/*#__PURE__*/c(o),u=/*#__PURE__*/d(n),p=/*#__PURE__*/d(s);const g=u.default.object().unknown().keys({id:u.default.string().required().description("Identifier for this particular rule."),active:u.default.boolean().description("If the rule is active or not. An inactive rule is not run at all."),ttl:u.default.date().default(0xfd4fff4e446).description("At this time (ISO timestamp) the rule will be set to inactive."),onLoad:u.default.any().description("Ploson code to e.g. create reusable constants and functions."),cooldown:u.default.number().min(0).description("A rule can't be triggered again unless this number of seconds has passed."),resetCondition:u.default.any().description("Ploson code to check if rule should reset, if it is in flipped state."),resetAction:u.default.any().description("Ploson code block to execute when resetCondition is true."),condition:u.default.any().default(!0).description("Ploson code to check if rule should execute (state to flipped, run actions etc)."),action:u.default.any().description("Ploson code block to execute when condition is true (& not in flipped state).")}),f=function({ploson:e,code:t,createReturn:r=l.identity}){try{return Promise.resolve(e(t)).then(function(e){return p.default(e)?Promise.reject(e):r(e)})}catch(e){return Promise.reject(e)}},R={delays:{COOLDOWN:({cooldown:e})=>e},guards:{hasCooldown:({cooldown:e})=>Boolean(e),hasHysteresis:({hysteresis:e})=>e,conditionTruthy:(e,{data:[t]=r.ARR})=>Boolean(t),isExpired:({ttl:e})=>i.isBefore(new Date)(e)},services:{checkIfExpired:({ttl:e},{payload:t})=>i.isBefore(new Date)(e)?Promise.reject(Error("Take onError path")):Promise.resolve({payload:t}),condition:({condition:e,ploson:t},{data:{payload:r}})=>f({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),resetCondition:({resetCondition:e,ploson:t},{payload:r})=>f({ploson:t,payload:r,code:[",",{payload:Promise.resolve(r)},e],createReturn:e=>[e,r]}),action:function({action:e,ploson:t},{data:[,o]=r.ARR}){try{return f({ploson:t,payload:o,code:[",",{payload:Promise.resolve(o)},e]})}catch(e){return Promise.reject(e)}},resetAction:({resetAction:e,ploson:t},{data:[,o]=r.ARR})=>f({ploson:t,payload:o,code:[",",{payload:Promise.resolve(o)},e]})},actions:{logError:(e,{data:t})=>console.error(t),updateRule:()=>t.assign({ttl:(e,{rule:{ttl:t}=r.OBJ})=>t,hysteresis:(e,{rule:{hysteresis:t}=r.OBJ})=>t,condition:(e,{rule:{condition:t}=r.OBJ})=>t,action:(e,{rule:{action:t}=r.OBJ})=>t,cooldown:(e,{rule:{cooldown:t}=r.OBJ})=>t,resetCondition:(e,{rule:{resetCondition:t}=r.OBJ})=>t,resetAction:(e,{rule:{resetAction:t}=r.OBJ})=>t})}},y=t.createMachine({predictableActionArguments:!0,initial:"idle",on:{INACTIVATE:"inactive",UPDATE:{actions:"updateRule"}},states:{inactive:{on:{ACTIVATE:"idle"}},idle:{on:{FIRE:"checkExpired"}},checkExpired:{invoke:{src:"checkIfExpired",onDone:"checkCondition",onError:"expired"}},checkCondition:{invoke:{src:"condition",onDone:[{cond:"conditionTruthy",target:"executeAction"},{target:"idle"}],onError:{actions:"logError",target:"idle"}}},executeAction:{invoke:{src:"action",onDone:{target:"fired"},onError:{actions:"logError",target:"fired"}}},fired:{type:"parallel",states:{switcher:{initial:"decide",states:{decide:{always:[{cond:"hasHysteresis",target:"flipped"},{target:"done"}]},flipped:{on:{FIRE:"checkCondition"}},checkCondition:{invoke:{src:"resetCondition",onDone:[{cond:"conditionTruthy",target:"executeResetAction"},{target:"flipped"}],onError:{actions:"logError",target:"executeResetAction"}}},executeResetAction:{invoke:{src:"resetAction",onDone:{target:"done"},onError:{actions:"logError",target:"done"}}},done:{type:"final"}}},temperature:{initial:"decide",states:{decide:{always:[{cond:"hasCooldown",target:"hot"},{target:"cool"}]},hot:{after:{COOLDOWN:"cool"}},cool:{type:"final"}}}},onDone:"idle"},expired:{type:"final"}}},R),E=l.differenceWith(({id:e}=r.OBJ,{id:t}=r.OBJ)=>e===t),h=({idKey:e="id",ignoreKeys:t,skipIf:r,transformAdded:o,transformUpdated:n}={})=>i=>l.converge(l.mergeLeft,[l.reduce((s,d)=>{if(r&&r(d))return s;const{[e]:c}=d,u=l.find(l.propEq("id",c))(i);if(u){const e=l.when(()=>t,l.map(l.omit(t)))([u,d]),r=a.createPatch(...e);return l.isEmpty(r)?s:{...s,updated:[...s.updated,n?n(d,u,r):d]}}return{...s,added:[...s.added,o?o(d):d]}},{added:[],updated:[]}),l.pipe(E(i),l.objOf("removed"))]),{pure:m,stop:v}=t.actions,A=l.groupBy(({callback:e})=>e?"updatedSoft":"updatedHard"),T=l.map(({trigger:e,ploson:t,...r})=>f({ploson:t,code:e,createReturn:o=>({...r,trigger:e,ploson:t,callback:o})})),k=(e,t)=>r=>e((e,o)=>r({type:"FIRE_RULES",targets:o??t,payload:e})),O=l.map(({id:e,targets:o,callback:n,...i})=>({id:e,targets:o,callback:n,...i,...n?{ref:t.spawn(k(n,o),e)}:r.OBJ})),w={predictableActionArguments:!0,id:"rule-manager",initial:"initRules",context:{rules:[],triggers:[]},states:{retryRules:{after:{RETRY_DELAY:{target:"initRules"}}},initRules:{invoke:{src:"ruleFetcher",onDone:"prepareRules",onError:{actions:"logError",target:"retryRules"}}},prepareRules:{invoke:{id:"processInitRules",src:"processRules",onDone:{actions:"addRules",target:"initTriggers"},onError:{actions:"logError",target:"initTriggers"}}},retryTriggers:{after:{RETRY_DELAY:{target:"initTriggers"}}},initTriggers:{invoke:{src:"triggerFetcher",onDone:{target:"prepareTriggers"},onError:{actions:"logError",target:"retryTriggers"}}},prepareTriggers:{invoke:{id:"processInitTriggers",src:"processTriggers",onDone:{actions:["addTriggers","spawnUpdater"],target:"running"},onError:{actions:"logError",target:"running"}}},running:{initial:"idle",on:{FIRE_RULES:{actions:"fireRules"}},states:{idle:{on:{UPDATE_RULES:{target:"updatingRules"},UPDATE_TRIGGERS:{target:"updatingTriggers"}}},updatingRules:{invoke:{id:"processRuleUpdates",src:"processRules",onDone:{target:"idle",actions:["killActors","removeRules","addRules","updateRules"]},onError:{target:"idle",actions:"logError"}}},updatingTriggers:{invoke:{id:"processTriggerUpdates",src:"processTriggers",onDone:{target:"idle",actions:["killActors","removeTriggers","addTriggers"]},onError:{target:"idle",actions:"logError"}}}}}}},P=e=>t.createMachine(w,(({ruleFetcher:e=(()=>Promise.resolve(r.ARR)),triggerFetcher:o=(()=>Promise.resolve(r.ARR)),staticEnv:n=r.OBJ,staticEnvTriggers:i=n,updater:s=r.FUNC})=>{const a=h({ignoreKeys:["ref","ploson","active"],skipIf:({active:e})=>!e,transformAdded:e=>{const{value:t,error:o,warning:i}=g.validate(e);return(o||i)&&console.warn(o||i),{...t,ploson:r.createRunner({staticEnv:n})}},transformUpdated:(e,{ploson:t,ref:r})=>({...e,ploson:t,ref:r})}),d=h({ignoreKeys:["ploson","callback","ref","active"],skipIf:({active:e})=>!e,transformAdded:({targets:e=r.ARR,...t})=>({...t,targets:e,ploson:r.createRunner({staticEnv:i})}),transformUpdated:(e,{ploson:t,callback:o,ref:n},i)=>({...e,ploson:t,ref:n,...l.any(l.propEq("path","/trigger"))(i)?r.OBJ:{callback:o}})});return{delays:{RETRY_DELAY:3e4},services:{ruleFetcher:e,triggerFetcher:o,processRules:function({rules:e},{data:t=r.ARR}){try{const{added:r,updated:o,removed:n}=a(e)(t);return Promise.resolve(Promise.all(l.map(({onLoad:e,ploson:t})=>e?f({ploson:t,code:e}):Promise.resolve())([...r,...o]))).then(function(){return{added:r,toRemove:n,toUpdate:o}})}catch(e){return Promise.reject(e)}},processTriggers:function({triggers:e},{data:t=r.ARR}){try{const{added:o,updated:n,removed:i}=d(e)(t),{updatedHard:s=r.ARR,updatedSoft:a=r.ARR}=A(n);return Promise.resolve(Promise.all(T([...o,...s]))).then(function(e){return{added:e,toRemove:[...i,...s],toUpdate:a}})}catch(e){return Promise.reject(e)}}},actions:{logError:(e,{data:t})=>console.error(t),killActors:m((e,{data:{toRemove:t=r.ARR,toRestart:o=r.ARR}=r.OBJ})=>l.into([],l.pipe(l.filter(({ref:e})=>Boolean(e)),l.map(({ref:e})=>v(e))))([...t,...o])),removeTriggers:t.assign({triggers:({triggers:e},{data:{toRemove:t=r.ARR}=r.OBJ})=>E(e,t)}),addTriggers:t.assign({triggers:({triggers:e},{data:{added:t=r.ARR}=r.OBJ})=>(console.info("Spawning triggers:",l.pluck("id",t)),[...e,...O(t)])}),updateTriggers:t.assign({triggers:({triggers:e},{data:{toUpdate:t=r.ARR}=r.OBJ})=>l.map(e=>{const r=l.find(l.propEq("id",e.id))(t);return r?l.assoc("targets",r.targets??[],e):e})(e)}),removeRules:t.assign({rules:({rules:e},{data:{toRemove:t=r.ARR}=r.OBJ})=>E(e,t)}),addRules:t.assign({rules:({rules:e},{data:{added:o=r.ARR}=r.OBJ})=>[...e,...l.map(({id:e,active:o,ttl:n,resetCondition:i,resetAction:s,cooldown:a,condition:d,action:c,ploson:l,...u})=>{const p=Boolean(i);return{id:e,active:o,ttl:n,ploson:l,...u,...o?{ref:t.spawn(y.withContext({ttl:n,hysteresis:p,condition:d,action:c,ploson:l,resetCondition:i,resetAction:s,cooldown:a}),e)}:r.OBJ}})(o)]}),updateRules:m((e,{data:{toUpdate:o=r.ARR}=r.OBJ})=>l.chain(({active:e,ttl:r,resetCondition:o,resetAction:n,cooldown:i,condition:s,action:a,ref:d})=>{const c=Boolean(o),l=t.send({type:"UPDATE",rule:{ttl:r,hysteresis:c,condition:s,action:a,resetCondition:o,resetAction:n,cooldown:i}},{to:d});return e?[l]:[t.send("INACTIVATE",{to:d}),l]})(o)),fireRules:m(({rules:e},{targets:r,payload:o})=>l.reduce((e,{id:n,active:i,ref:s})=>i&&s&&l.includes(n,r)?[...e,t.send({type:"FIRE",payload:o},{to:s})]:e,[])(e)),spawnUpdater:t.assign({updaterRef:()=>t.spawn(s,"rule-trigger-updater")})}}})(e));e.Rule=g,e.createRuleEngine=function(){return t.interpret(P(...[].slice.call(arguments)))},e.createRuleEngineMachine=P});
//# sourceMappingURL=ploson-rule-engine.umd.js.map
